#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>
#include <string.h>

FILE *openpbm(char *name, int *wp, int *hp, int *npixp);
void readpbm(FILE *fp, int width, int height, FILE *ofile);

int main(int ac, char *av[])
{
    static char *names[] = {"bkg", "off", "on", "pwr", NULL};
    char **np, buf[80];
    FILE *fp, *ofile;
    int w, h, npix;

    ofile = fopen("ppm.c", "w");
    if (!ofile)
	exit(1);
    fprintf(ofile, "#include \"ppm.h\"\n");

    for (np = names; *np; np++) {
	sprintf(buf, "%s.ppm", *np);
	printf("open %s\n", buf);
	fp = openpbm(buf, &w, &h, &npix);
	if (fp) {
	    fprintf(ofile, "\nstatic unsigned char p_%s_bytes[] = {\n", *np);
	    readpbm(fp, w, h, ofile);
	    fprintf(ofile, "};\n");
	    fprintf(ofile, "\nstruct ppm p_%s = { %d, %d, %d, p_%s_bytes };\n", *np, w, h, npix, *np);
	    fclose(fp);
	}
    }

    fclose(ofile);
    exit(0);
}

FILE *
openpbm(char *name, int *wp, int *hp, int *npixp)
{
    FILE *fp;
    char buf[200];

    sprintf(buf, "%s", name);
    fp = fopen(buf, "r");
    if (!fp)
	return NULL;
    if (fgets(buf, sizeof buf, fp) == NULL || strncmp(buf, "P6", 2)) {
	fclose(fp);
	return NULL;
    }
    buf[0] = '#';
    while (buf[0] == '#') {
	if (fgets(buf, sizeof buf, fp) == NULL) {
	    fclose(fp);
	    return NULL;
	}
    }

    sscanf(buf, "%d %d", wp, hp);
    fgets(buf, sizeof buf, fp);
    sscanf(buf, "%d", npixp);

    return fp;
}

void readpbm(FILE *fp, int width, int height, FILE *ofile)
{
    char *bp;
    int x, y, c;

    for (y = 0; y < height; y++) {
	for (x = 0; x < width; x++)
	    for (c = 0; c < 3; c++)
		fprintf(ofile, "%d,", getc(fp));
//		fprintf(ofile, "%d,", getc(fp) * GSCLD / npix);
	fprintf(ofile, "\n");
    }
}
